;@sa1 <-- DO NOT REMOVE THIS LINE!
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Real homing bill shooter - Advanced version
; by 33953YoShI
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; This shooter behavior is depend on block number at same positions as it.
;
; Shot directions is depend on 1 digit of block number.
; 0 ~ 7 : Fixing cannon
;
; 5 6 7
; 4 + 0
; 3 2 1
;
; 8,C : left or right, it behavior is same as Standard version.
; 9,D : up or down
; A,E : diagonal, left up or right down
; B,F : diagonal, left down or right up
;
; Generated sprite and interval for generate is depend on 2 digit of block number.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; Uses first extra bit: YES
; Generated sprite's extra bit will be set same value as this shooter.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		!SE_Shot_SFX =		$09		;\ Choose Shot SFX
		!SE_Shot_RAM =		$1DFC		;/

; Set to be generated sprite number and interval for generate.
CustSetting:	db $12,$60		; Tile x0x,x8x
		db $12,$60		; Tile x1x,x9x
		db $12,$60		; Tile x2x,xAx
		db $12,$60		; Tile x3x,xBx
		db $12,$60		; Tile x4x,xCx
		db $12,$60		; Tile x5x,xDx
		db $12,$60		; Tile x6x,xEx
		db $12,$60		; Tile x7x,xFx

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

; SA-1 pack - Memory remap
		!BW =		$6000
		
		!9E =		$3200
		!AA =		$9E
		!B6 =		$B6
		!C2 =		$D8
		!D8 =		$3216
		!E4 =		$322C

		!00AA =		$309E
		!00B6 =		$30B6
		!00C2 =		$30D8
		!009E =		$3200
		!00D8 =		$3216
		!00E4 =		$322C
		!14C8 =		$3242
		!14D4 =		$3258
		!14E0 =		$326E
		!151C =		$3284
		!1528 =		$329A
		!1534 =		$32B0
		!1540 =		$32C6
		!154C =		$32DC
		!1558 =		$32F2
		!1564 =		$3308
		!1570 =		$331E
		!157C =		$3334
		!1588 =		$334A
		!1594 =		$3360
		!15A0 =		$3376
		!15AC =		$338C
		!15EA =		$33A2
		!15F6 =		$33B8
		!1602 =		$33CE
		!160E =		$33E4
		!163E =		$33FA
		!187B =		$3410
		
		!14EC =		$74C8
		!14F8 =		$74DE
		!1504 =		$74F4
		!1510 =		$750A
		!15B8 =		$7520
		!15C4 =		$7536
		!15D0 =		$754C
		!15DC =		$7562
		!161A =		$7578
		!1626 =		$758E
		!1632 =		$75A4
		!190F =		$7658
		!1FD6 =		$766E
		!1FE2 =		$7FD6
		!164A =		$75BA
		!1656 =		$75D0
		!1662 =		$75EA
		!166E =		$7600
		!167A =		$7616
		!1686 =		$762C
		!186C =		$7642
		
		!RAM_BackwardDistL =	!1534
		!RAM_BackwardDistH =	!1528
		!RAM_AngleL =		!1504
		!RAM_AngleH =		!151C

		!RAM_ExtraBits =	$6040
		!RAM_NewSpriteNum =	$6083
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

		print "INIT ",pc
		print "MAIN ",pc
		PHB
		PHK
		PLB
		LDA.w $178B|!BW,x
		BIT #$08
		BNE +
		JSR InitCode
+		JSR MainCode
		PLB
		RTL
		
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

InitCode:	LDA.w $178B|!BW,x
		AND #$F0
		STA $98
		LDA.w $1793|!BW,x
		STA $99
		LDA.w $179B|!BW,x
		AND #$F0
		STA $9A
		LDA.w $17A3|!BW,x
		STA $9B
		STZ.w $1933|!BW
		JSR GetBlockSA1
		STA $00
		LSR #4
		AND #$07
		ORA #$08
		ORA $98
		STA.w $178B|!BW,x
		LDA $00
		AND #$0F
		ORA $9A
		STA.w $179B|!BW,x
Return:		RTS
		
MainCode:	LDA.w $17AB|!BW,x
		BNE Return
		LDA.w $179B|!BW,x
		AND #$0F
		STA $04
		TAY
		LDA.w CheckTable,y
		STA $02
		LDA.w $178B|!BW,x
		AND #$07
		ASL A
		TAY
		LDA.w CustSetting,y
		STA $03
		LDA.w CustSetting+$01,y
		STA.w $17AB|!BW,x
		LDA.w $179B|!BW,x
		AND #$F0
		STA $01
		LDA.w $178B|!BW,x
		AND #$F0
		STA $00
		CMP $1C
		LDA.w $1793|!BW,x
		SBC $1D
		BNE Return
		LDA.w $17A3|!BW,x
		XBA
		LDA $01
		REP #$21
		ADC.w #$0010
		SEC
		SBC $1A
		CMP.w #$0120
		SEP #$20
		BCS Return
		BIT $02
		BMI Generate
		LDA $94
		ADC #$11
		SEC
		SBC $01
		CMP #$22
		BCS Generate
		BIT $02
		BVC Return
		LDA $96
		ADC #$20
		SEC
		SBC $00
		CMP #$40
		BCC Return
		
Generate:	JSL $02A9DE
		BMI Return
		LDA.w $1783|!BW,x
		STA $02
		TYX
		LDA $03
		STA !RAM_NewSpriteNum,x
		JSL $07F7D2
		LDA #$88
		BIT $02
		BVC +
		ORA #$04
+		STA !RAM_ExtraBits,x
		LDA #$01
		STA !RAM_BackwardDistH,x
		LDA #$80
		STA !RAM_BackwardDistL,x
		LDA #$01
		STA !14C8,x
		LDA.b #!SE_Shot_SFX
		STA.w !SE_Shot_RAM|!BW
		TXY
		LDX.w $15E9|!BW
		
		LDA.w $179B|!BW,x
		AND #$F0
		STA $9A
		STA !00E4,y
		LDA.w $17A3|!BW,x
		STA !14E0,y
		STA $9B
		LDA.w $178B|!BW,x
		AND #$F0
		STA $98
		SEC
		SBC #$01
		STA !00D8,y
		LDA.w $1793|!BW,x
		SBC #$00
		STA !14D4,y
		STA $99
		LDA $04
		ASL A
		TAX
		CPX #$10
		BCC .Fixing
		REP #$21
		JSR.w (PtrTable-$10,x)
		SEP #$20
		STA !RAM_AngleL,y
		XBA
		BRA +
.Fixing		LDA.w AngleTable,x
		STA !RAM_AngleL,y
		XBA
		LDA.w AngleTable+$01,x
+		STA !RAM_AngleH,y
		XBA
		REP #$20
		ASL #2
		XBA
		SEP #$20
		AND #$07
		TAY
		LDX.w $15E9|!BW
		JMP SubSmoke
		
AngleTable:	dw $0000,$0040,$0080,$00C0,$0100,$0140,$180,$01C0

PtrTable:	dw CheckLR,CheckUD,CheckLU_RD,CheckLD_RU
		dw CheckLR,CheckUD,CheckLU_RD,CheckLD_RU
		
CheckTable:	db $00,$80,$40,$80,$00,$80,$40,$80
		db $00,$40,$80,$80,$00,$40,$80,$80
		
CheckLR:	LDA $94
		CMP $9A
		BPL +
		LDA.w #$0100
		RTS
+		LDA.w #$0000
		RTS
		
CheckUD:	LDA $96
		ADC.w #$0010
		CMP $98
		BPL +
		LDA.w #$0180
		RTS
+		LDA.w #$0080
		RTS
		
CheckLU_RD:	LDA $94
		SEC
		SBC $9A
		STA $00
		LDA $98
		SEC
		SBC.w #$0018
		SEC
		SBC $96
		STA $02
		PHP
		BPL +
		EOR.w #$FFFF
		INC A
		STA $02
		LDA $00
		EOR.w #$FFFF
		INC A
		STA $00
+		LDA $00
		SEC
		SBC $02
		BPL +			;\
		BVS .RD			; | BGE .RD
		BRA .LU			; |
+		BVC .RD			;/
.LU		LDA.w #$0140
		PLP
		BPL +
		LDA.w #$0040
+		RTS

.RD		LDA.w #$0040
		PLP
		BPL +
		LDA.w #$0140
+		RTS


CheckLD_RU:	LDA $94
		SEC
		SBC $9A
		STA $00
		LDA $96
		CLC
		ADC.w #$0010
		SEC
		SBC $98
		STA $02
		PHP
		BPL +
		EOR.w #$FFFF
		INC A
		STA $02
		LDA $00
		EOR.w #$FFFF
		INC A
		STA $00
+		LDA $00
		SEC
		SBC $02
		BPL +			;\
		BVS .RU			; | BGE .RU
		BRA .LD			; |
+		BVC .RU			;/
.LD		LDA.w #$00C0
		PLP
		BPL +
		LDA.w #$01C0
+		RTS

.RU		LDA.w #$01C0
		PLP
		BPL +
		LDA.w #$00C0
+		RTS

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

SubSmoke:	LDA .XofsL,y
		STA $00
		CLC
		ADC $9A
		TAX
		LDA .XofsH,y
		ADC $9B
		CPX $1A
		SBC $1B
		BNE .Return
		LDA .YofsL,y
		STA $01
		CLC
		ADC $98
		TAX
		LDA .YofsH,y
		ADC $99
		CPX $1C
		SBC $1D
		BNE .Return

		LDY #$03
.FindFree	LDA.w $17C0|!BW,y
		BEQ .FoundFree
		DEY
		BPL .FindFree
		BRA .Return

.FoundFree	LDA #$01
		STA.w $17C0|!BW,y
		LDA $98
		CLC
		ADC $01
		STA.w $17C4|!BW,y
		LDA #$1B
		STA.w $17CC|!BW,y
		LDA $9A
		CLC
		ADC $00
		STA.w $17C8|!BW,y
.Return		LDX.w $15E9|!BW
		RTS

.XofsL		db $0C,$08,$00,$F8,$F4,$F8,$00,$08
.XofsH		db $00,$00,$00,$FF,$FF,$FF,$00,$00
.YofsL		db $00,$08,$0C,$08,$00,$F8,$F4,$F8
.YofsH		db $00,$00,$00,$00,$00,$FF,$FF,$FF

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
; GetBlock
; this routine will get Map16 value
; If position is invalid range, will return 0xFFFF.
;
; input:
; $98-$99 block position Y
; $9A-$9B block position X
; $1933   layer
;
; output:
; A Map16 lowbyte
; Y Map16 highbyte
;
; $65-$68 will be destructed.
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

GetBlockSA1:	LDA $5B
		AND #$01
		TAY
		LDA #$20
		CPY #$01
		BCC .Horz0
		LDA #$1C
.Horz0		BIT $5B
		BPL .Layer1_0
		LSR A
.Layer1_0	CPY #$01
		BCC .Horz1
		CMP $99
		BCC .RangeOver
		LDA $9B
		CMP #$02
		BCC .Next
.RangeOver	LDA #$FF
		TAY
		RTS

.Horz1		CMP $9B
		BCC .RangeOver
		LDA $98
		CMP #$B0
		LDA $99
		SBC #$01
		BCS .RangeOver
.Next		LDA.w $1933|!BW
		REP #$21
		BEQ .Layer1_1
		TYA
		BEQ .Horz2
		LDA $98
		ADC.w #$0E00
		AND.w #$FFF0
		STA $67
		BRA +
.Horz2		LDA $98
		AND.w #$FFF0
		STA $67
		LDA $9A
		ADC.w #$1000
		BRA .Common0
.Layer1_1	LDA $98
		AND.w #$FFF0
		STA $67
+		LDA $9A
.Common0	SEP #$20
		LSR #4
		STA $65
		XBA
		CPY #$01
		BCC .Horz3
		STA $66
		ASL $68
		REP #$21
		LDA.w #$0000
		BRA .Common1
.Horz3		STA $2252
		REP #$21
		STZ $2250
		LDA.w #$01B0
		STA $2253
		LDY #$00		;\ wait 5 cycles...
		STY $66			;/
		LDA $2307
.Common1	ADC $67
		ADC $65
		ADC.w #$C800
		STA $65
		SEP #$20
		LDA #$41
		STA $67
		LDA [$65]
		TAY
		DEC $67
		LDA [$65]
		RTS
		